//
//  StudentDetailViewController.h
//  StudentManager
//
//  Created by Rich on 2/9/11.
//  Copyright 2011 Swarthmore College. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Student.h"

@class StudentDetailViewController;

@protocol StudentDetailViewControllerDelegate
- (void)studentEditedForStudentDetailViewContollerDelegate:(StudentDetailViewController *)sender;
- (void)viewSwipedForStudentDetailViewContollerDelegate:(StudentDetailViewController *)sender direction:(int)direction;
@end

@interface StudentDetailViewController : UIViewController <UITextFieldDelegate, UISplitViewControllerDelegate> {
	UITextField *nameField;
	UITextField *gradyearField;
	UITextField *majorField;
	
	UIButton *backgroundButton;
	
	id <StudentDetailViewControllerDelegate> delegate;
	
	Student *editStudent;
}

@property (retain) IBOutlet UITextField *nameField;
@property (retain) IBOutlet UITextField *gradyearField;
@property (retain) IBOutlet UITextField *majorField;

@property (retain) IBOutlet UIButton *backgroundButton;

@property (assign) Student *editStudent;
@property (assign) id <StudentDetailViewControllerDelegate> delegate;


- (IBAction)backgroundTouched:(UIButton *)sender;

@end
